#include <cstdio>
#include <vector>

using std::vector;

#define MAXN 256
#define MAXD 2000000000

struct reb {
	int num;
	double t;
	int l, v;

	reb(int _n, int _v, int _l) {
		num = _n;
		v = _v;
		l = _l;
		if(v!=0) t=(double)l/(double)v; else t = MAXD;
	}
	
	reb() {};
};


int n,m,d;
vector < vector <reb> > G;

double dist[MAXN];
char used[MAXN];


double Gf[256][256];

int main() {
	scanf("%d%d%d",&n,&m,&d);
	G.resize(n+2);
	int a,b,v,l;
	for(int i=0;i<m;++i) {
		scanf("%d%d%d%d",&a,&b,&v,&l);
		--a;--b;
		G[a].push_back(reb(b,v,l));
		G[b].push_back(reb(a,v,l));
	}
	for(int i=0;i<n;++i) {
		for(int j=0;j<G[i].size();++j) {
			if(G[i][j].v==0) {
				for(int k=0;k<G[i].size();++k) {
					if(G[i][k].num==j||G[i][k].num==i) continue;
					G[G[i][k].num].push_back( reb( G[i][j].num, G[i][k].v, G[i][k].l+G[i][j].l ) );
				}
			}
		}
	}
	
	for(int i=0;i<n;++i) for(int j=0;j<n;++j) Gf[i][j]=MAXD;
	for(int i=0;i<n;++i) {
		for(int j=0;j<G[i].size();++j) {
			if(G[i][j].t<Gf[i][G[i][j].num]) Gf[i][G[i][j].num]=G[i][j].t;
		}	
	}
	for(int k=0;k<n;++k) {
		for(int i=0;i<n;++i) {
			for(int j=0;j<n;++j) {
				if(Gf[i][j]>Gf[i][k]+Gf[k][j]) Gf[i][j]=Gf[i][k]+Gf[k][j];
			}
		}
	}
	
	printf("%lf\n",Gf[0][d-1]);
	return 0;
	
}
